<?php

require("Configuration.php");

/**
 * Very simple implementation of a Configuration.
 *
 * @author Daniel J. Lauk <daniel.lauk@psi.ch>
 */
class SimpleConfiguration implements Configuration {

    private $settings = array();

    private function getSetting($key) {
        if (!key_exists($key, $this->settings))
            throw new RuntimeException("Configuration item '$key' is not set.");
        return $this->settings[$key];
    }

    private function getSettingOrDefault($key, $default) {
        try {
            $val = $this->getSetting($key);
        } catch (RuntimeException $e) {
            $val = $default;
        }
        return $val;
    }

    public function __construct($settings) {
        $this->settings = $settings;
    }

    public function getConfiguredSettings() {
        $keys = array_keys($this->settings);
        asort($keys);
        return $keys;
    }

    public function getString($key) {
        $val = $this->getSetting($key);
        return $val;
    }

    public function getStringOrDefault($key, $default) {
        $val = $this->getSettingOrDefault($key, $default);
        return $val;
    }

    public function getInteger($key) {
        $val = $this->getSetting($key);
        return $val;
    }

    public function getIntegerOrDefault($key, $default) {
        $val = $this->getSettingOrDefault($key, $default);
        return $val;
    }

    public function getBoolean($key) {
        $val = $this->getSetting($key);
        return $val;
    }

    public function getBooleanOrDefault($key, $default) {
        $val = $this->getSettingOrDefault($key, $default);
        return $val;
    }
}

?>
